#include<windows.h>
#include<iostream.h>
#include<winsock.h>

DWORD	ServiceThread(LPDWORD param);
void	install(void);
void	remove(void);

#define				NO_FLAG_SET		0
#define				MAXBUFLEN		1024
#define				LOG_FILE		"c:\\temp\\x10broker.log"

DWORD	ServiceThread(LPDWORD param);
void	install(void);
void	remove(void);


struct ControlCommand
{
	char			addressCommand[4];
	char			actionCommand[4];
};

struct PolicyScript
{
	struct ControlCommand	conditionInfo;
	char					actionScript[100];
};

struct PolicyInfo
{
	int						policyInfoCount;
	struct PolicyScript		policyScript[30];
};

struct EventBrokerThreadInfo
{
	int				serverPort;
	HANDLE			comPortHandle;
};

struct EventListenerThreadInfo
{
	HANDLE				comPortHandle;
	struct PolicyInfo	policyInfo;
};



class ComPanic
{
public:
	ComPanic(int level, char *recvmsg)
	{
		GetLocalTime(&st);

		_itoa(st.wYear,buf,10);
		strcpy(msg,buf);
		strcat(msg,"/");
		_itoa(st.wMonth,buf,10);
		strcat(msg,buf);
		strcat(msg,"/");
		_itoa(st.wDay,buf,10);
		strcat(msg,buf);
		strcat(msg," ");
		_itoa(st.wHour,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wMinute,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wSecond,buf,10);
		strcat(msg,buf);
		strcat(msg," ");

		strcat(msg,recvmsg);
	}

	int severity() 
	{
		return level;
	}
	
	char* reason() 
	{

		FILE *f;

		if ((f = fopen(LOG_FILE, "a")) != NULL)
		{
			fprintf(f,msg);
			fclose(f);
		}

		return msg; 
	}

private:
	char	msg[100];
	int		level;
	SYSTEMTIME	st; 
	char	buf[5];


};



class SocketPanic
{
public:
	SocketPanic(int level, char *recvmsg)
	{
		GetLocalTime(&st);

		_itoa(st.wYear,buf,10);
		strcpy(msg,buf);
		strcat(msg,"/");
		_itoa(st.wMonth,buf,10);
		strcat(msg,buf);
		strcat(msg,"/");
		_itoa(st.wDay,buf,10);
		strcat(msg,buf);
		strcat(msg," ");
		_itoa(st.wHour,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wMinute,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wSecond,buf,10);
		strcat(msg,buf);
		strcat(msg," ");

		strcat(msg,recvmsg);
	}

	int severity() 
	{
		return level;
	}
	
	char* reason() 
	{

		FILE *f;

		if ((f = fopen(LOG_FILE, "a")) != NULL)
		{
			fprintf(f,msg);
			fclose(f);
		}

		return msg; 
	}

private:
	char	msg[100];
	int		level;
	SYSTEMTIME	st; 
	char	buf[5];
};

class ThreadPanic
{
public:
	ThreadPanic(int level, char *recvmsg)
	{
		GetLocalTime(&st);

		_itoa(st.wYear,buf,10);
		strcpy(msg,buf);
		strcat(msg,"/");
		_itoa(st.wMonth,buf,10);
		strcat(msg,buf);
		strcat(msg,"/");
		_itoa(st.wDay,buf,10);
		strcat(msg,buf);
		strcat(msg," ");
		_itoa(st.wHour,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wMinute,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wSecond,buf,10);
		strcat(msg,buf);
		strcat(msg," ");

		strcat(msg,recvmsg);
	}

	int severity() 
	{
		return level;
	}
	
	char* reason() 
	{

		FILE *f;

		if ((f = fopen(LOG_FILE, "a")) != NULL)
		{
			fprintf(f,msg);
			fclose(f);
		}

		return msg; 
	}

private:
	char	msg[100];
	int		level;
	SYSTEMTIME	st; 
	char	buf[5];
};

class FilePanic
{
public:
	FilePanic(int level, char *recvmsg)
	{
		GetLocalTime(&st);

		_itoa(st.wYear,buf,10);
		strcpy(msg,buf);
		strcat(msg,"/");
		_itoa(st.wMonth,buf,10);
		strcat(msg,buf);
		strcat(msg,"/");
		_itoa(st.wDay,buf,10);
		strcat(msg,buf);
		strcat(msg," ");
		_itoa(st.wHour,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wMinute,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wSecond,buf,10);
		strcat(msg,buf);
		strcat(msg," ");

		strcat(msg,recvmsg);
	}

	int severity() 
	{
		return level;
	}
	
	char* reason() 
	{

		FILE *f;

		if ((f = fopen(LOG_FILE, "a")) != NULL)
		{
			fprintf(f,msg);
			fclose(f);
		}

		return msg; 
	}

private:
	char	msg[100];
	int		level;
	SYSTEMTIME	st; 
	char	buf[5];	
};

class X10EventBroker
{
public:

	X10EventBroker(
		HANDLE comHandle,
		int serverPort);			// Constructor

	start();
	end();

private:

	SOCKET				listenSocket;
	SOCKET				clientSocket;
	bool				lifeFlag;

	int					clientPort;

	HANDLE				comPortHandle;
	int					serverPort;
};

class X10EventListener
{
public:

	X10EventListener(
		HANDLE cph,
		struct PolicyInfo pi);			// Constructor

	start();
	parse_and_execute(struct ControlCommand &cc);
	end();

private:
	int					clientPort;
	HANDLE				comPortHandle;
	struct PolicyInfo	policyInfo;
};

